# Evil Genius on the Oregon Trail 
# Copyright 2006 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import random
import pygame
from pygame.locals import *
from gutil import *

DEATH_MESSAGES = ["The pressure got to you...",
                  "And you just bought that machine...",
                  "Be more careful with your toys...",
                  "What's wrong with this thing?"]

MESSAGE_WIN = 0
MESSAGE_LOSE = 1
MESSAGE_HELP = 2

BIG_Y_MESSAGE_POS = 30
Y_MESSAGE_POS = 200
                  
class Final(pygame.sprite.Sprite):
    main_image = None
    font_large = None
    font_very_large = None
    alpha = 128
    
    def __init__(self,message_type):
        pygame.sprite.Sprite.__init__(self)

        message = None
        
        if message_type == MESSAGE_WIN:
            self.image = load_image("win.png")
            big_message = "Winner!"
            message = "You'll be eating well for months!"
            self.alpha = 255
            
        elif message_type == MESSAGE_LOSE:
            self.image = load_image("rubble.png")
            big_message = "Destroyed!"
            message = DEATH_MESSAGES[random.randint(0,len(DEATH_MESSAGES)-1)]
            self.alpha = 255
            
        elif message_type == MESSAGE_HELP:
            self.image = load_image("manual.png",None)
            self.alpha = 255

        self.image.set_alpha(self.alpha)
        self.rect = self.image.get_rect()

        self.color =  Color('blue')
        if not (message == None):
            self.font_very_large = pygame.font.Font("data/underattack.ttf", 75)
            font_image = self.font_very_large.render(big_message,1,self.color)
            self.image.blit(font_image,(self.rect.centerx-font_image.get_rect().width/2,BIG_Y_MESSAGE_POS))
            
            self.font_large = pygame.font.Font("data/underattack.ttf", 30)
            font_image = self.font_large.render(message,1,self.color)
            self.image.blit(font_image,(self.rect.centerx-font_image.get_rect().width/2,Y_MESSAGE_POS))

        self.font_small = pygame.font.Font("data/underattack.ttf", 20)
        font_image = self.font_small.render("Press SPACE to continue...",1,self.color)
        self.image.blit(font_image,(self.rect.centerx-font_image.get_rect().width/2,560))

    def update(self):
        pass
    
