# Evil Genius on the Oregon Trail 
# Copyright 2006 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import pygame
from pygame.locals import *
import os.path

SCREENRECT = Rect(0, 0, 800, 600)
TITLE = "Evil Genius on the Oregon Trail"
STATUS_RECT = Rect(0,SCREENRECT.height-(0.2*SCREENRECT.height),SCREENRECT.width,0.2*SCREENRECT.height)

# Scaling based on y
SCALE_BOTTOM = 0.90
SCALE_TOP = 0.50

# Weight/Steam
WEIGHT_DIVISOR = 10

def load_image(name, colorkey=-1):
    if name == 'null':
        return None
    
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    image = image.convert()
    return image

def clip_bottom(obj,area):
    bottom = obj.bottom - area.bottom
    if bottom < 0:
        return obj

    if obj.top < area.bottom:
        # Don't draw anything
        return Rect(obj.left,obj.top,obj.width,0)

    return Rext(obj.left,obj.top,obj.width,bottom)

def scale_on_field(position_y):
    field_height = STATUS_RECT.top
    slope = (SCALE_BOTTOM-SCALE_TOP)/field_height
    return SCALE_TOP+slope*(1.0*position_y)

def required_pressure(weight):
    return weight/WEIGHT_DIVISOR
