# Evil Genius on the Oregon Trail 
# Copyright 2006 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import random
import pygame
from pygame.locals import *
from gutil import *

MENU_Y_OFFSET = 150

# Possible selections
MENU_PLAY=0
MENU_HELP=1
MENU_QUIT=2

class MainMenu(pygame.sprite.Sprite):
    font_large = None
    alpha = 200
    selected = 0
    new_game = 1
    main_image = None

    selected_color = Color('red')
    unselected_color = Color('blue')
    
    def __init__(self,screen):
        pygame.sprite.Sprite.__init__(self)

        #self.main_image = load_image("menu.png",None)
        self.main_image = pygame.Surface((screen.get_rect().width,screen.get_rect().height))
        self.main_image.convert()
        self.main_image.fill(Color('green'))
        
        self.font_large = pygame.font.Font("data/underattack.ttf", 75)

        # Title
        title1 = self.font_large.render("Evil Genius",1,self.unselected_color)
        title2 = pygame.font.Font("data/underattack.ttf", 40).render("on the Oregon Trail",1,self.selected_color)

        self.main_image.blit(title1,(10,4))
        self.main_image.blit(title2,(10,91))

        # Author
        author1 = pygame.font.Font("data/underattack.ttf", 30).render("PrintStar's Entry",1,self.unselected_color)
        author2 = pygame.font.Font("data/underattack.ttf", 30).render("for PyWeek 2 (2006)",1,self.unselected_color)
        author3 = pygame.font.Font("data/underattack.ttf", 30).render("Licensed under the GNU GPL",1,self.unselected_color)

        self.main_image.blit(author1,(500,20))
        self.main_image.blit(author2,(500,50))
        #self.main_image.blit(author3,(525,65))

        author2 = pygame.font.Font("data/underattack.ttf", 30).render("Copyright 2006 Jeff Armstrong (aka PrintStar)",1,self.unselected_color)
        author3 = pygame.font.Font("data/underattack.ttf", 30).render("Licensed under the GNU GPL",1,self.unselected_color)
        self.main_image.blit(author2,(20,480))
        self.main_image.blit(author3,(200,510))

        self.rect = self.main_image.get_rect()

    def increment_selected(self,amt=1):
        self.selected = self.selected + amt
        self.limit()

    def limit(self):
        if self.selected < 0:
            self.selected = 0
        if self.selected > 2:
            self.selected = 2

    def decrement_selected(self):
        self.increment_selected(-1)

    def set_selection(self,selection):
        self.selected = selection
        self.limit()

    def get_selection(self):
        return self.selected

    def set_newgame(self):
        self.new_game = 1

    def set_resumegame(self):
        self.new_game = 0

    def is_newgame(self):
        return self.new_game
    
    def update(self):
        self.image = self.main_image.copy()

        # A bit transparent
        self.image.set_alpha(self.alpha)

        render = [None,None,None]
        texts = ["Resume Game","Manual","Quit"]
        if self.new_game:
            texts[0] = "New Game"

        # Draw each option
        for x in range(0,3):
            if x==self.selected:
                color = self.selected_color
            else:
                color = self.unselected_color
                
            entry = self.font_large.render(texts[x],1,color)
            self.image.blit(entry,(self.rect.centerx-entry.get_rect().width/2,MENU_Y_OFFSET+x*100))

        
        
        
        
