# Evil Genius on the Oregon Trail 
# Copyright 2006 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import pygame
from pygame.locals import *
from gutil import *

class Score(pygame.sprite.Sprite):
    current_score = 0
    size = (115,50)            # Measured from png file of control panel
    rel_to_picture = (34,STATUS_RECT.top+26)
    
    blit_y = 10

    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = pygame.Surface(self.size)
        self.image.convert()
        self.image.set_colorkey(self.image.get_at((1,1)))
        self.rect = self.image.get_rect()
        self.rect.topleft = self.rel_to_picture
        self.font = pygame.font.Font("data/primeministerofcanada.ttf", 30)
        self.color = Color('white')

    def increment_score(self,amt):
        self.current_score = self.current_score+amt

    def get_score(self):
        return self.current_score

    def reset(self):
        self.current_score = 0

    def update(self):
        if self.current_score > 9999:
            thousands = hundreds = tens = ones = '*'
        else:
            thousands = str(self.current_score/1000)
            hundreds = str(self.current_score/100 % 10)
            tens = str(self.current_score/10 % 10)
            ones = str(self.current_score % 10)

        th_i = self.font.render(thousands,1,self.color)
        hu_i = self.font.render(hundreds,1,self.color)
        te_i = self.font.render(tens,1,self.color)
        on_i = self.font.render(ones,1,self.color)

        # Clear current score
        self.image.fill(self.image.get_colorkey())

        # blit on the scores
        self.image.blit(th_i,(2,self.blit_y))
        self.image.blit(hu_i,(32,self.blit_y))
        self.image.blit(te_i,(62,self.blit_y))
        self.image.blit(on_i,(92,self.blit_y))
