# Evil Genius on the Oregon Trail 
# Copyright 2006 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import pygame
from pygame.locals import *

STEAM_DECAY_MS = 3500
INITIAL_ALPHA = 200
MOVE_DELAY_MS = 30
MOVE_STEP = 3

NEW_STEAM_INTERVAL_MS = 100

class Steam(pygame.sprite.Sprite):
    alpha = INITIAL_ALPHA
    radius = 15
    start_time = 0
    last_time = 0
    def __init__(self,position):
        pygame.sprite.Sprite.__init__(self)

        self.image = pygame.Surface((2*self.radius,2*self.radius))
        self.image.convert()
        self.image.set_colorkey(self.image.get_at((1,1)))

        self.rect = pygame.draw.circle(self.image,Color('white'),(self.radius,self.radius),self.radius,0)

        self.image.set_alpha(self.alpha)
        self.rect.center = position

    def is_done(self):
        if self.alpha <= 0 or self.rect.bottom <= 0:
            return 1
        else:
            return 0

    def update(self):

        current_time = pygame.time.get_ticks()
        
        if self.start_time == 0:
            self.start_time = current_time
        else:
            self.alpha = (INITIAL_ALPHA*(STEAM_DECAY_MS-(current_time-self.start_time)))/STEAM_DECAY_MS
            if self.alpha < 0:
                 self.alpha = 0
            self.image.set_alpha(self.alpha)

        if current_time - self.last_time > MOVE_DELAY_MS:
            self.rect.bottom = self.rect.bottom - MOVE_STEP
            if self.rect.bottom < 0:
                self.rect.bottom = 0
            self.last_time = current_time
            
        
        
